proc ach2001(th);
    @ This proc evaluates the ach model likelihood and evaluates lambda(t) 
      Global variables:
	    capt	= size of original data matrix
            t0 		= first observation of subsample
	    t1 		= last observation of subsample
	    z 		= (capt x kz) matrix of explanatory variables, including constant term
            q 		= (capt x 1) vector of values of q vector (only t0 through t1 are used)  
            h 		= (t1 - t0 + 1) vector of hazards 
            kc 		= 2 means print out misc data (kc = 1 for no print)
            kqopt 	= 1 means beta, theta parameterized so as to insure nonnegativity
            use kqopt   = 2 for final call to likelihood ) @

local del, bet, thet, it, lagq,
lamb, el, elal, del2,mz,m;

@ read in parameters @
	{del,bet,thet} = achin(th);

@ generate q vector @ 

    lagq = q[t0,1];
    it = t0+1;
    do until it > t1;
        q[it,1] = thet*duration[it-1,1] + bet*lagq;
	if event[it,1] > 0;
		lagq = q[it,1];
	endif;
   it = it+1;
   endo;
 			        	

@ calculate lambda values and likelihood @

 mz = q[t0:t1,1] + z[t0:t1,.]*del; 
mz = maxc(   ( (mz .>0) .* (2*dellit*mz^2) ./ (dellit^2 + mz^2))' | (mz .* (mz .> dellit))'  ); 

mz = mz + delsmall;
h = 1 ./ (1 +  mz );


if (minc(h) < 1.e-300) or (minc(1-h) < 1.e-300);
    el = zeros(t1-t0+1,1);
    elal = -2000;
else;
    el = event[t0:t1,1].*ln(h) + (1 - event[t0:t1,1]).*ln(1 - h); 
    elal = sumc(el);
endif;
if philcont == 13;
	if datex[679,1] .ne 33463;
		"date of observation 679 is not 33463";
		end;
	endif;
	elal = elal - el[679,1];
	el[679,1] = 0;
endif;

if kc > 1;
    "week target  q  hazard  log like ";
  mz =  datex ~ price ~ q[t0:t1,1]~h~el; mz;
   "";"mean value for q";;meanc(q[t0:t1,1]);
    "mean duration";; meandur; 
   "";"----------------";"value of log likelihood";;elal;
endif;

retp(-elal);
endp;
