proc achnoex(th);
    @ This proc evaluates the ach model likelihood and evaluates lambda(t) 
          under specification with no exogenous variables 
      Global variables:
	    capt	= size of original data matrix
            t0 		= first observation of subsample
	    t1 		= last observation of subsample
	    z 		= (capt x kz) matrix of explanatory variables, including constant term
            q 		= (capt x 1) vector of values of q vector (only t0 through t1 are used)  
            h 		= (t1 - t0 + 1) vector of hazards 
            kc 		= 2 means print out misc data (kc = 1 for no print)
            kqopt 	= 1 means beta, theta parameterized so as to insure nonnegativity
            use kqopt   = 2 for final call to likelihood ) @

local del, bet, thet, it, lagq,
lamb, el, elal, del2,mz,m;

@ read in parameters @
	if kcorr == 1;
		{bet,thet} = achinnoex(th);
	elseif kcorr == 2;
		bet = 0;
		del = th[1,1];
		thet = th[2,1];
	endif;

@ generate q vector @ 

    lagq = q[t0,1];
    it = t0+1;
    do until it > t1;
        q[it,1] = thet*duration[it-1,1] + bet*lagq;
	if event[it,1] > 0;
		lagq = q[it,1];
	endif;
   it = it+1;
   endo;
  if kcorr == 2;
	q = q + del;
  endif; 			        	

@ calculate lambda values and likelihood @

q = maxc (   (q .<= 1)' |   
     ( (q .> 1) .* (q .<= (1 + dellit) ) .* (  ( 1 + 2*dellit*(q - 1)^2) ./ (dellit^2 + (q - 1)^2) )  )' |
     ( (q .> (1 + dellit) ) .* q)'  ); 

q = q + delsmall;
h = 1 ./  q ;


    el = event[t0:t1,1].*ln(h) + (1 - event[t0:t1,1]).*ln(1 - h); 
    elal = sumc(el);

if philcont == 13;
	if datex[679,1] .ne 33463;
		"date of observation 679 is not 33463";
		end;
	endif;
	elal = elal - el[679,1];
	el[679,1] = 0;
endif;

if kc > 1;
    "week target  q  hazard  log like ";
  mz =  datex ~ price ~ q[t0:t1,1]~h~el; mz;
   "";"mean value for q";;meanc(q[t0:t1,1]);
    "mean duration";; meandur; 
   "";"----------------";"value of log likelihood";;elal;
endif;

retp(-elal);
endp;
