/*******************************************************************
		This GAUSS Program Summarizes the wholesdale price data 
********************************************************************/
output file=datasum.out reset;

ll = 0;
n = 0;
proc(2) = lsq(yq,x1);
   @ This proc performs an OLS regression of yq on x1 
        and puts value of log likelihood in the global scalar ll @
local b,eps,sigols,sigmle,ss,nq;
  b = invpd(x1'*x1)*x1'*yq;
   eps = yq - x1*b;
  sigols = sumc(eps^2)/(rows(x1)-cols(x1));
   sigmle = sumc(eps^2)/rows(x1);
   ss = sigols*invpd(x1'*x1);
   ll = -(n/2)*(1 + ln(2*pi)) - (n/2)*ln(sigmle);
    ""; "ols coefficients";b';
     "ols see";;sqrt(sigols);
    "mle see";;sqrt(sigmle);
    "standard errors";sqrt(diag(ss))';
    "ols log likelihood";; ll;"";
retp(b,sigmle^.5);
endp;

price = 0;  event = 0; nobs = 0; @ keeps proc from tripping error when loaded @
proc directb(ser);
	@ this proc takes a ser (a nobs x 1 vector of prices) and calculates the median
		logarithmic change among those observations with price changes @
local medb, istart;
medb = abs(ln(price[2:nobs,1] ./ price[1:nobs-1,1]));
medb = sortc(medb,1);
istart = 1;
do until istart > nobs -1;
	if medb[istart,1] > 0;
		medb = medb[istart:nobs-1,1];
		medb = medb[trunc( (nobs - istart) / 2),1];
		istart = nobs;
	endif;
istart = istart + 1;
endo;
retp(medb);
endp;


philcont = 1;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);

philcont = 2;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);

philcont = 4;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 7;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 11;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 12;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 13;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 15;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


philcont = 16;
#include readdata.g;
nobs;;meangap;;meanc(event);
n = nobs;
{bhat,sigmle} = lsq(loggapnext,loggap);
"median b is";; directb(price);


