/*******************************************************************
		This GAUSS Program Reads in the wholesdale price data 
********************************************************************/


/********************************************************************
	READ IN NYMEX HARBOR PRICE
 ********************************************************************/
capt = 782;
load nymex[capt,2] = ..\data\nymex.csv;
	@ col. 1 = date, col. 2 = nymex price @

qdat = zeros(capt,6);    @ this will serve to store the data for 
                           a particular dealer, leaving zeros for
		               missing observations @

/*********************************************************************
	LOAD THE APPROPRIATE PHILADELPHIA DATA
*********************************************************************/

 "dealer analyzed is number";;philcont;

if philcont == 1;
     load z[] = ..\data\jhphil1.csv; 
elseif philcont == 2;
	load z[] = ..\data\mdphil2.csv;
elseif philcont == 4;
	load z[] = ..\data\mdphil4.csv;
elseif philcont == 7;
	load z[] = ..\data\jhphil7.csv;
elseif philcont == 11;
	load z[] = ..\data\mdphil11.csv;
elseif philcont == 12;
	load z[] = ..\data\jhphil12.csv;
elseif philcont == 13;
	load z[] = ..\data\jhphil13.csv;
elseif philcont == 15;
	load z[] = ..\data\mdphil15.csv;
elseif philcont == 16;
	load z[] = ..\data\jhphil16.csv;
else;
	"no data for philcont = ";;philcont;
	end;
endif;

/********************************************************************
	FILL IN QDAT MATRIX AT APPROPRIATE POSITIONS
 ********************************************************************/
tstart = 1;
if philcont == 7;
	tend = 641;
	if rows(z) == (tend - tstart + 1)*6;
		qdat = reshape(z,tend - tstart +1,6);
	else;
	      "rows and columns of ";;philcont;; "not as specified";
	      end;
	endif;
elseif philcont == 12;
	tend = 743;
	if rows(z) == (tend - tstart + 1)*6;
		qdat = reshape(z,tend - tstart +1,6);
	else;
	      "rows and columns of ";;philcont;; "not as specified";
	      end;
	endif;
elseif philcont == 13;
	@ Series 13 is missing what in other series would be observations 	         679 (8/8/91) through 681 (8/12/91) @
	nymex = nymex[1:678,.] | nymex[682:capt,.];
	tstart = 1;
	tend = 779;
	if rows(z) == (tend - tstart + 1)*6;
		qdat[tstart:tend,.] = reshape(z,tend - tstart +1,6);
	else;
	      "rows and columns of ";;philcont;; "not as specified";
	      end;
	endif;

elseif philcont == 16;
	tstart = 21;    @ starting date for this firm is 1/30/89 @
	tend = 701;     @ ending date for this firm is 9/9/91 @
	if rows(z) == (tend - tstart + 1)*6;
		qdat[tstart:tend,.] = reshape(z,tend - tstart +1,6);
	else;
	      "rows and columns of ";;philcont;; "not as specified";
	      end;
	endif;
else; 
   tend = capt;
   if rows(z) == 4692;
      qdat = reshape(z,capt,6);
   else;
      "rows and columns of ";;philcont;; "not as specified";
      end;
   endif;
endif;

/*********************************************************************
	READ VARIABLES OFF OF LOADED DATA
  ********************************************************************/

datex = qdat[tstart:tend,1];
price = qdat[tstart:tend,2];
change = qdat[tstart:tend,3];
event = qdat[tstart:tend,4];
curdur = qdat[tstart:tend,5];
duration = qdat[tstart:tend,6];
chex = datex - nymex[tstart:tend,1];
if chex'*chex > 0;
	"error: dates on wholesale price and pstar don't match up ";
	end;
endif;
pstar =  nymex[tstart:tend,2];

/**********************************************************************
	CONSTRUCT VARIABLES USED IN ANALYSIS
 **********************************************************************/

@ -------- calculate nobs, the number of usable observations in the series @
nobs = rows(event);     

@ -------- calculate gap, the previous day's difference between the firm's 
  price and the nymex price @
gap = (0 | (price[1:nobs-1,1] - pstar[1:nobs-1,1]) );

@ -------- calculate gapc, the deviation of gap from its mean @
meangap = meanc(gap[2:nobs,1]);
gapc = gap;
gapc[2:nobs,1] = gapc[2:nobs,1] - meangap;

@ -------- calculate absgapc, the absolute value of gapc @
absgapc = abs(gapc);    

@ -------- calculate gapc2, the previous day's value of gapc @
gapc2 = 0 | gapc[1:nobs-1,1];

@ -------- calculate lastgap.  Row t of lastgap is the difference between
           the firm's price and the nymex price on the most recent day prior
           to t on which the firm changed its price, less the average gap @
lastgap = zeros(nobs,1);
storelast = 0;
i = 1;
do until i > nobs;
	lastgap[i,1] = storelast;
	if event[i,1] == 1;
		storelast = price[i,1] - pstar[i,1] - meangap;
	endif;
i = i + 1;
endo;
				
@ --------- calculate abslastgap, the absolute value of deviation of lastgap
            from the mean gap @
abslastgap = abs(lastgap);

@ --------- calculate negtrend, a dummy variable that is 1 if the previous 
            day's mark-up was below average @
negtrend = gapc .< zeros(nobs,1);

@ -------- calculate ntrinter, product of negtend with gapc  @
ntrinter = negtrend .* gapc;

@ -------- calculate loggap, the deviation of the logarithmic gap for the previous day 
              from its mean @
loggap = ln(price ./ pstar);
loggap = loggap - meanc(loggap);
loggapnext = loggap;
loggap = 0 | loggap[1:nobs-1,1];

@ ---------- calculate positive and negative gap terms @
posconst = gapc .>= zeros(nobs,1);
negconst = gapc .< zeros(nobs,1);
posgap = gapc .* posconst;
neggap = -gapc .* negconst;








