proc menu2001(th);
    @ This proc evaluates the menu cost model likelihood 
      Global variables:
            t0 		= first observation of subsample
	    t1 		= last observation of subsample
          z = (t1 -t0 +1)x 1 vector, row t is previous day's price minus ny price
            h 		= (t1 - t0 + 1) vector of hazards 
            kc 		= 2 means print out misc data (kc = 1 for no print)
            kqopt 	= 1 means b, sig parameterized so as to insure nonnegativity
            use kqopt   = 2 for final call to likelihood ) @

local b, sig,  it, el, elal, mz ;

@ read in parameters @
	{b,sig} = menuin(th);

@ generate h vector @ 
/* "b is";;b;
"sig is";;sig;
"max devs are"; 
elal = minc((z - b) / sig );elal;;elal = maxc ( (z + b)/sig); elal;  */
    h = 1 + cdfn( (z - b)/sig  )- cdfn(  (z + b)/sig );

if (minc(h) < 1.e-300) or (minc(1-h) < 1.e-300);
    el = zeros(t1-t0+1,1);
    elal = -2000;
else;
    el = event[t0:t1,1].*ln(h) + (1 - event[t0:t1,1]).*ln(1 - h); 
    elal = sumc(el);
endif;
if philcont == 13;
	if datex[679,1] .ne 33463;
		"date of observation 679 is not 33463";
		end;
	endif;
	elal = elal - el[679,1];
	el[679,1] = 0;
endif;
if kc > 1;
    "date price hazard  log like ";
  mz =  datex ~ price ~h~el; mz;
   "";"mean value for h";;meanc(h[t0:t1,1]);
   " mean probability";;meanc(event);
   "";"----------------";"value of log likelihood";;elal;

endif;

retp(-elal);
endp;
